// utf-8

/*	Threshold Sorter (alternating buffer variant)		adaptable via #defines
	---------------------------------------------		----------------------

	Copyright  (c)	Günter Woigk   1998-2003
  					mailto:kio@little-bat.de

	This file is free software

 	This program is distributed in the hope that it will be useful,
 	but WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

 	Permission to use, copy, modify, distribute, and sell this software and
 	its documentation for any purpose is hereby granted without fee, provided
 	that the above copyright notice appear in all copies and that both that
 	copyright notice and this permission notice appear in supporting
 	documentation, and that the name of the copyright holder not be used
 	in advertising or publicity pertaining to distribution of the software
 	without specific, written prior permission. The copyright holder makes no
 	representations about the suitability of this software for any purpose.
 	It is provided "as is" without express or implied warranty.

 	THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 	INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 	EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 	DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 	TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 	PERFORMANCE OF THIS SOFTWARE.


<German>
	Der zu sortierende Bereich wird in drei Felder unterteilt: 
		1. vorsortierte Elemente unterhalb (<=) einer unteren Schranke
		2. noch unsortierte Elemente
		3. vorsortierte Elemente oberhalb (>=) einer oberen Schranke

	Start:
		Falls 1. Element > letztes Element  =>  diese beiden vertauschen
		Feld 1 := 1. Element
		Feld 3 := letztes Element
		Untere Schranke := 1. Element
		Obere Schranke  := letztes Element

	Danach wird abwechselnd das erste und das letzte Element des mittleren, noch
	unsortierten Feldes betrachtet:
		Element[i] <= untere Grenze => unterem Bereich zuordnen
		Element[i] >= obere Grenze  => oberem Bereich zuordnen
		Element[i] dazwischen => 
			dem unteren bzw. oberen Bereich zuordnen und Grenzwert entsprechend neu setzen

		Dabei wird dem Bereich der Vorrang gegeben, an den Element[i] grenzt:
		Wird also gerade das erste Element des mittleren Bereiches betrachtet,
		wird es vorzugsweise dem unteren sortierten Feld zugeschlagen, sonst anders rum.

		Damit muss das Element gar nicht verschoben/vertauscht werden und durch das
		alternieren wird die Wahrscheinlichkeit für eine symmetrische Größe der vorsortierten
		Bereiche erhöht. (sie ist aber leider nicht besonders hoch.)

	Ist der gesamte Bereich vorsortiert, also das mittlere Feld leer, werden die beiden
	vorsortierten Felder rekursiv nach gleichem Schema sortiert.


	Vorteile:
		nicht quadratischer Zeitzuwachs
		benötigt keinen temp array
		nur das Vergleichs-Makro BEHIND(A,B) muss implementierbar sein
		(man kann damit also alles sortieren, was überhaupt sortierbar ist.)

	Nachteil:
		Die Reihgenfolge von Elementen mit gleichem Wert wird verwürfelt
		(also ungeeignet für's Sortieren von Datenbanken nach 2 oder mehr Spalten)
</German>


	Macros:
	-------
	
	Name		Meaning						Default
	-----------	---------------------------	----------------
	TYPE		type of data in array		int
	BEHIND(A,B)	compare function			A>B
	SWAP(A,B)	swap two items in array		z=A,A=B,B=z
	SORTER		name of sorter function		Sort	


	Examples:
	---------

	1. sort array of ints:
	
			#include "sort.h"
	
	
	2.	A sorter for floats:

			#define		TYPE				float
			#include	"sort.h"


	3.	A sorter for c-type strings:
		(first 4 characters only)
		 
			#define		TYPE				char*
			#define		BEHIND(A,B)			*(long*)A>*(long*)B		// PowerPC, m68k 
			#include	"sort.h"
			

	4. member function of class Var to sort array of pointers to Var:

			typedef 	Var*		VarPtr;
			#define 	TYPE		VarPtr
			#define 	BEHIND(A,B)	(*(A)>*(B))
			#define 	SWAP(A,B)	::Swap(A,B), ::Swap((A)->index,(B)->index)
			#define 	SORTER		Var::Sort
			#include	"sort.h"
*/



/******	default settings ***********************************
*/
#ifndef TYPE
#define TYPE			int
#endif
#ifndef BEHIND
#define BEHIND(A,B)		((A)>(B))
#endif
#ifndef SWAP
#define SWAP(A,B)		z=A,A=B,B=z
#endif
#ifndef SORTER
#define SORTER 			Sort
#endif

#ifdef SORT
#undef SORT
#endif
#define SORT(A,B)		if(BEHIND(A,B)) { SWAP(A,B); }

#ifdef _METROWERKS
#pragma warn_unusedvar off
#endif



/******	Sort range [a ... [e *************************************
*/	
void SORTER ( TYPE* a, TYPE* e )
{	XXXTRAP(!a||!e);
	XXXTRAP(a>e || a+(e-a)!=e);

	TYPE* a_stack[sizeof(void*)<<3];
	TYPE* e_stack[sizeof(void*)<<3];
	int pushed = 0;
	
	TYPE z;		// provided for simple SWAP macro
	(void)z;

	e--;

	for(;;)
	{	
		XXXTRAP(e<a);
	
		switch(e-a)
		{
		case 2:
			SORT(a[0],a[2]);
			SORT(a[1],a[2]);
		case 1:
			SORT(a[0],a[1]);
		case 0:
		case -1:
			if (pushed)
			{
				pushed--;
				a = a_stack[pushed];
				e = e_stack[pushed];
				continue;
			}
			return;
		}

	// 4 oder mehr Elemente
		TYPE* a0 = a;
		TYPE* e0 = e;
		
		SORT(*a,*e);

		TYPE* a_lim = a++;
		TYPE* e_lim = e--;

		for(;;)
		{
			if (a>=e) break;
			
			if (BEHIND(*a,*a_lim))
				if (BEHIND(*e_lim,*a))
					a_lim = a++;
				else
					SWAP((*a),(*e)), e--;
			else
				a++;
			
			if (a>=e) break;
			
			if (BEHIND(*e_lim,*e))
				if (BEHIND(*e,*a_lim))
					e_lim = e--;
				else
					SWAP((*a),(*e)), a++;
			else
				e--;
		}

	// letztes Element unten oder oben zuschlagen.				kio 3.nov.2001
	// wäre unnötig, wenn in der schleife oben das abbruchkriterium (a>b) verwendet würde.
	// dann würde das letzte Element aber häufig mit sich selbst geswappt, was stören kann.
		if (BEHIND(*a,*a_lim)) e--; else a++;
			

	//	XXXLogLine("Sort(%d-%d)",e-a0+1,e0-a+1);
		XXXTRAP(pushed==NELEM(a_stack));

	// größeren der subbereiche [a0..e] und [a..e0] pushen, den anderen sofort sortieren
	// ((nötig, um stacküberlauf sicher zu vermeiden))
		if (e-a0>e0-a)
		{
			a_stack[pushed] = a0;
			e_stack[pushed] = e;
			pushed++;

			a = e;
			e = e0;
		}
		else
		{
			a_stack[pushed] = a;
			e_stack[pushed] = e0;
			pushed++;

			a = a0;
			e = e;
		}
	}
}


#ifdef _METROWERKS
#pragma warn_unusedvar reset
#endif

#undef TYPE
#undef SORT
#undef BEHIND
#undef SWAP
#undef SORTER










